//
//  PDFViewer.m
//  PDFViewer
//
//  Created by Markus Bröker on 27.03.17.
//  Copyright © 2017 Markus Bröker. All rights reserved.
//

#import "PDFViewer.h"

@implementation PDFViewer

-(void) awakeFromNib {
    synthesizer = [[NSSpeechSynthesizer alloc] initWithVoice:[NSSpeechSynthesizer defaultVoice]];
}

-(NSMutableString*) getTexts {
    NSMutableString *strings = [[NSMutableString alloc] init];
    NSUInteger nOps = [[self document] pageCount];
    
    [strings appendString: [NSString stringWithFormat: @"Genosse Parteisekretär, das Dokument hat %lu Seiten", nOps]];
    
    for (int pages = 0; pages < nOps; pages++) {
        PDFPage *page = [[self document] pageAtIndex: pages];
        [strings appendString: [self replaceString: [page string]]];
    }
    
    return strings;
}

-(void) speak: (NSMutableString*) texts {
    // Die Audioausgabe muss immer gestoppt werden, bevor Sie erneut gestartet werden darf!
    [self stopSpeaking];
    
    [synthesizer startSpeakingString:texts];    
}

-(void) stopSpeaking {
    if ([synthesizer isSpeaking]) {
        [synthesizer stopSpeaking];
    }
}

-(NSString*) replaceString: (NSString*) inputStr {
    NSDictionary *replacements = @{
       @"SED": @"S.E.D.",
       @"DDR": @"D.D.R.",
       @" IM ": @" I.M. ",
    };
    
    for (id key in replacements) {
        inputStr = [inputStr stringByReplacingOccurrencesOfString:key withString: replacements[key]];
    }
    
    return inputStr;
}

@end
